-------------------------------------------------------------------------------
-- ElvUI Chat Tweaks By Lockslap (US, Bleeding Hollow)
-- <Borderline Amazing>, http://ba-guild.com
-- Based on functionality provided by Prat and/or Chatter
-------------------------------------------------------------------------------
local Module	= ElvUI_ChatTweaks:NewModule("Pet Battles", "AceConsole-3.0", "AceEvent-3.0")
local L			= ElvUI_ChatTweaks.L
Module.name		= L["Pet Battles"]

local db, options
local defaults = {
	profile = {
		color	= {r = 0.72, g = 0.63, b = 0.31},	-- tannish/yellowish
		frame	= "ChatFrame3",
	}
}

local lastMsg		= ""
local frameString	= "ChatFrame%d"
local frameList		= L["Chat Frame %d"]

local function PetBattleFilter(self, event, message)
	if not message or not _G[db.frame] then return false end
	if Module.debug then
		_G[db.frame]:AddMessage("I'm using this ChatFrame.")
		print(message)
	end
	
	if message ~= lastMsg then	-- prevent duplicate messages
		_G[db.frame]:AddMessage(message, db.color.r, db.color.g, db.color.b)
		lastMsg = message
	end
	return true
end

function Module:OnEnable()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PET_BATTLE_INFO", PetBattleFilter)
end

function Module:OnDisable()
	ChatFrame_RemoveMessageEventFilter("CHAT_MSG_PET_BATTLE_INFO", PetBattleFilter)
end

function Module:OnInitialize()
	self.db = ElvUI_ChatTweaks.db:RegisterNamespace("PetBattles", defaults)
	db = self.db.profile
	Module.debug = ElvUI_ChatTweaks.db.profile.debugging
end

function Module:GetOptions()
	if not options then
		options = {
			color = {
				type	= "color",
				order	= 13,
				name	= L["Message Color"],
				get		= function() return db.color.r, db.color.g, db.color.b end,
				set		= function(_, r, g, b) db.color.r = r; db.color.g = g; db.color.b = b; end,
			},
			frame = {
				type	= "select",
				order	= 14,
				name	= L["Output Frame"],
				desc	= L["Chat frame to route the messages to."],
				get		= function() return db.frame end,
				set		= function(_, value) db.frame = value end,
				values	= function()
					local frames = {}
					for i = 1, 18 do
						if _G[frameString:format(i)] then
							frames[frameString:format(i)] = frameList:format(i)
						end
					end
					return frames
				end,
			},
		}
	end
	return options
end

function Module:Info()
	return L["Allows you to color the pet battle info messages, and determine which chat frame to send them to."]
end